﻿using System;

namespace WpfWVVMSample
{

    internal class MainViewModel : NotificationObject
    {
        public MainViewModel()
        {
            _calc = new Calculator();
        }

        private string _lhs; // 割られる数

        public string Lhs
        {
            get { return this._lhs; }
            set
            {
                if (SetProperty(ref this._lhs, value))
                {
                    this.DivCommand.RaiseCanExecuteChanged();
                }
            }
        }

        private string _rhs;

        public string Rhs
        {
            get { return this._rhs; }
            set { if (SetProperty(ref this._rhs, value))
                {
                    this.DivCommand.RaiseCanExecuteChanged();
                }
            }
        }

        private string _result;

        public string Result
        {
            get { return this._result; }
            private set { SetProperty(ref this._result, value); }
        }

        private DelegateCommand _divCommand;

        public DelegateCommand DivCommand
        {
            get
            {
                if (this._divCommand == null) {

                    Action<object> execute = _ => OnDivision();
                    Func<object, bool> canCondition = _ =>
                    {
                        var lhs = 0.0;
                        var rhs = 0.0;
                        if (!double.TryParse(this.Lhs, out lhs))
                        {
                            return false;
                        }
                        if (!double.TryParse(this.Rhs, out rhs))
                        {
                            return false;
                        }
                        return true;
                    };

                    var delegateCommand = new DelegateCommand(execute, canCondition);
                    this._divCommand = delegateCommand;
                }
                return this._divCommand;
            }
        }

        private void OnDivision()
        {
            this._calc.Lhs = double.Parse(this.Lhs);
            this._calc.Rhs = double.Parse(this.Rhs);
            this._calc.ExecuteDiv();
            this.Result = this._calc.Result.ToString();
        }

        private Calculator _calc;
    }
}
